/*! Copyright (C) [2011] [David Mainzer]
 * 
 *  This program is free software; you can redistribute it and/or modify it under the terms 
 *  of the GNU General Public License as published by the Free Software Foundation; either 
 *  version 3 of the License, or (at your option) any later version.
 *  
 *  This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; 
 *  without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
 *  See the GNU General Public License for more details.
 *  
 *	You should have received a copy of the GNU General Public License along with this program; 
 *	if not, see <http://www.gnu.org/licenses/>.  
 */

/**  Wenn etwas in dieser Klasse fehlt, fügt dies ruhig hinzu :)
*
*  ID1 --- Spring --- ID2 
*  
*  WITH:
*  ID1 = MassPoint 1
*  ID2 = MassPoint 2
*/

public class Spring {
	// Spring ID
	private final int m_ID1;
	private final int m_ID2;
	
	// length of the springs
	private final float m_spring_length_init;

        // stiffness
	private float stiffness;
	private float damper;
	
	// constructors
	public Spring( int ID1, int ID2 )
	{
		this.m_ID1 = ID1;
		this.m_ID2 = ID2;
		this.m_spring_length_init = 0.11F;
		this.stiffness = 50f;
		this.damper    = 4.0f;
	}
	
	public Spring( int ID1, int ID2, float length )
	{
		this.m_ID1 = ID1;
		this.m_ID2 = ID2;
		this.m_spring_length_init = length;
		this.stiffness = 50f;
		this.damper    = 4.0f;
	}
	
	public Spring( int ID1, int ID2, float length, float stiff )
	{
		this.m_ID1 = ID1;
		this.m_ID2 = ID2;
		this.m_spring_length_init = length;
		this.stiffness = stiff;
		this.damper    = 4.0f;
	}
	
	public Spring( int ID1, int ID2, float length, float stiff, float damp )
	{
		this.m_ID1 = ID1;
		this.m_ID2 = ID2;
		this.m_spring_length_init = length;
		this.stiffness = stiff;
		this.damper    = damp;
	}
	
	public void setStiffness (float stiff)
	{
		// hier muss die Federkonstante berechnet werden
		this.stiffness = stiff;
	}
	
	public float getStiffness (float length)
	{
		// hier muss die Federkonstante berechnet werden
		return stiffness;
	}
	
	public void setDamper (float damper)
	{
		// hier muss die Dämpfung berechnet werden
		this.damper=damper;
	}
	
	public float getDamper (float length)
	{
		// hier muss die Dämpfung berechnet werden
		return damper;
	}
	
	public int getId1()
	{
		return this.m_ID1;
	}
	
	public int getId2()
	{
		return this.m_ID2;
	}
	
	public float getInitLength()
	{
		return this.m_spring_length_init;
	}
}